/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2006 by Alexander D. Alexeev
//   http://alex-boss.narod.ru
//   mailto:Alex.D.Alexeev@gmail.com
//
// You may do whatever you like with this file, I just don't care.
// If you find this code useful, credits would be nice!
// If you have any suggestions, welcome!
//
/////////////////////////////////////////////////////////////////////////////

// LogView.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "TrayIcon.h"

HANDLE g_hHeap = NULL;
HMODULE g_hModule = NULL;

static OSVERSIONINFO *g_posVersion;
#define g_osVersion (*g_posVersion)

static DLLVERSIONINFO *g_pshellVersion;
#define g_shellVersion (*g_pshellVersion)

#if USE_FULL_OS_INFO==1
struct VersionData
{
	TCHAR *szName;
	WORD dwMajor, dwMinor;
};

static VersionData g_allVersion[] = 
{
	{ TEXT("Unknown"),	0,	0},
	{ TEXT("Windows 95"),				4,	0},
	{ TEXT("Windows 98"),				4,	10},
	{ TEXT("Windows Me"),				4,	90},
	{ TEXT("Windows NT 3.51"),	3,	51},
	{ TEXT("Windows NT 4.0"),		4,	0},
	{ TEXT("Windows 2000"),			5,	0},
	{ TEXT("Windows XP"),				5,	1},
	{ NULL,								0,	0},
};

static const TCHAR *szOSInfoFormat = TEXT("Starting LogView...\r\n OS: %s (%d.%d.%d %s)\r\n Shell: %d.%d.%d\r\n");
#endif // USE_FULL_OS_INFO==1

static const TCHAR *szRegKey = TEXT("Software\\PIC\\LogView\\Settings");
static const TCHAR *szMutexName = TEXT("MYAPPNAME-EC639BF0-A932-405F-8895-16CBA8FB90B9");

HANDLE g_hLogFile = 0;

DWORD	g_lTextLimit = 0;
BOOL g_bInTray = FALSE;
BOOL g_bTotalHide = TRUE;
UINT WMU_LOGVIEW_CLEAR = 0;
UINT UWM_ARE_YOU_ME = 0;
UINT WM_TASKBARCREATED = 0;

static HWND 
	hWndLog=0, 
	hWndFilterSt=0, 
	hWndFilter=0, 
	hWndClear=0;
static HFONT	g_hLogFont = NULL;
static LOGFONT	g_LogFont;
static HICON	g_hTrayIcon;

#define DEFER_WND_POS(dwp, hWnd, rc) ::DeferWindowPos(dwp, hWnd, NULL, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, SWP_NOZORDER)
#define PLACEMENT_ENT	(TEXT("WindowPlacement"))

#define WRITE_STR_TO_FILE(hFile, str) {DWORD dwWritten; ::WriteFile(hFile, str, lstrlen(str), &dwWritten, NULL);}
//CTrayIcon g_TrayIcon;
static CTrayIcon *g_pTrayIcon;
#define g_TrayIcon (*g_pTrayIcon)

TCHAR * __cdecl strstr_ (
											 const TCHAR * str1,
											 const TCHAR * str2
											 );

// WindowPlacement
BOOL LoadWindowRect(HWND hWnd, BOOL bRectOnly)
{
	WINDOWPLACEMENT wp;

	HKEY hKey;
	DWORD dwDisp, dwSize;
	::RegCreateKeyEx(HKEY_CURRENT_USER, szRegKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	dwSize = sizeof(WINDOWPLACEMENT);
	BOOL bRes = ::RegQueryValueEx(hKey, PLACEMENT_ENT, 0, NULL, (LPBYTE)&wp, &dwSize) == ERROR_SUCCESS;
	::RegCloseKey(hKey);
	
	if (!bRes)	// never saved before
		return FALSE;
	
	RECT& rc = wp.rcNormalPosition;	// alias
	if (bRectOnly)	// restore size/pos only
		return ::SetWindowPos(hWnd, NULL, rc.left, rc.top,
			rc.right-rc.left, rc.bottom-rc.top, SWP_NOACTIVATE | SWP_NOZORDER |
			SWP_NOREPOSITION);
	else	// restore also min/max state
		return ::SetWindowPlacement(hWnd, &wp);
}

BOOL SaveWindowRect(HWND hWnd, BOOL bRectOnly)
{
	WINDOWPLACEMENT wp;
	ZeroMemory(&wp, sizeof(WINDOWPLACEMENT));
	wp.length = sizeof(WINDOWPLACEMENT);
	if (!::GetWindowPlacement(hWnd, &wp))
		return FALSE;
	
	RECT& rc = wp.rcNormalPosition;
	if (bRectOnly)	// save size/pos only (normal state)
	{
		// use screen coordinates
		::GetWindowRect(hWnd, &rc);
		wp.showCmd = SW_NORMAL;
		wp.flags = 0;
	}

	HKEY hKey;
	DWORD dwDisp;
	::RegCreateKeyEx(HKEY_CURRENT_USER, szRegKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	BOOL bRes = ::RegSetValueEx(hKey, PLACEMENT_ENT, 0, REG_BINARY, (LPBYTE)&wp, sizeof(WINDOWPLACEMENT)) == ERROR_SUCCESS;
	::RegCloseKey(hKey);
	return bRes;
}

inline LPVOID APINew(DWORD dwSize)
{
	return ::HeapAlloc(g_hHeap, HEAP_ZERO_MEMORY, dwSize);
}

inline BOOL APIFree(LPVOID lpBlock)
{
	return ::HeapFree(g_hHeap, 0, lpBlock);
}

void CreateTrayIcon(HWND hWndParent, HICON hIcon)
{
#if USE_BALOON_INFO==1
	g_TrayIcon.CreateTrayIcon(hWndParent, WM_USER, TEXT("LogView Tool"), (HICON)hIcon, IDR_MENU, TEXT("LogView Tool"), TEXT("Click here to show window"));
#else
	g_TrayIcon.CreateTrayIcon(hWndParent, WM_USER, TEXT("LogView Tool"), (HICON)hIcon, IDR_MENU, NULL, NULL);
#endif //USE_BALOON_INFO==1
	if (g_bTotalHide)
		g_TrayIcon.HideIcon();
	else
		g_TrayIcon.ShowIcon();
}

BOOL OnInitDialog(HWND hWnd, LPARAM lParam)
{
	::SendMessage(hWnd, WM_SETICON, ICON_BIG, lParam);
	::SendMessage(hWnd, WM_SETICON, ICON_SMALL, lParam);

	hWndLog=::GetDlgItem(hWnd, IDC_LOG);
	hWndFilterSt=::GetDlgItem(hWnd, IDC_FILTER_ST);
	hWndFilter=::GetDlgItem(hWnd, IDC_FILTER);
	hWndClear=::GetDlgItem(hWnd, IDC_CLEAR);
	
	::SetFocus(hWndLog);

	HKEY hKey;
	DWORD dwDisp, dwSize;
	int nHeight;
	TCHAR szFontFace[32];
	::RegCreateKeyEx(HKEY_CURRENT_USER, szRegKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	dwSize = 4;
	if (::RegQueryValueEx(hKey, TEXT("FontSize"), 0, NULL, (LPBYTE)&nHeight, &dwSize) != ERROR_SUCCESS)
	{
		nHeight = 14;
		::RegSetValueEx(hKey, TEXT("FontSize"), 0, REG_DWORD, (LPBYTE)&nHeight, 4);
	}
	dwSize = 32;
	if (::RegQueryValueEx(hKey, TEXT("FontFace"), 0, NULL, (LPBYTE)&szFontFace, &dwSize) != ERROR_SUCCESS)
	{
		lstrcpy(szFontFace, TEXT("Courier"));
		::RegSetValueEx(hKey, TEXT("FontFace"), 0, REG_SZ, (LPBYTE)&szFontFace, 32);
	}

	dwSize = 4;
	if (::RegQueryValueEx(hKey, TEXT("HideFromTB"), 0, NULL, (LPBYTE)&g_bTotalHide, &dwSize) != ERROR_SUCCESS)
	{
		g_bTotalHide = TRUE;
		::RegSetValueEx(hKey, TEXT("HideFromTB"), 0, REG_DWORD, (LPBYTE)&g_bTotalHide, 4);
	}
	
	::RegCloseKey(hKey);

	ZeroMemory(&g_LogFont, sizeof(LOGFONT));
	g_LogFont.lfHeight = nHeight;
	lstrcpy(g_LogFont.lfFaceName, szFontFace);
	g_hLogFont = ::CreateFontIndirect(&g_LogFont);
	::SendMessage(hWndLog, WM_SETFONT, (WPARAM)g_hLogFont, TRUE);
	::SendMessage(hWndLog, EM_LIMITTEXT, (WPARAM)g_lTextLimit, 0);

	HMENU hSysMenu = ::GetSystemMenu(hWnd, FALSE);
	if (hSysMenu)
	{
#if USE_FONT_SETUP==1
		HMENU hSetupMenu = ::LoadMenu(g_hModule, MAKEINTRESOURCE(IDR_SETUP));
		HMENU hSubMenu = ::GetSubMenu(hSetupMenu, 0);
#endif
		::AppendMenu(hSysMenu, MF_SEPARATOR, 0, 0);
		::AppendMenu(hSysMenu, MF_STRING, IDC_CLEAR, TEXT("C&lear"));
		::AppendMenu(hSysMenu, MF_STRING, IDC_FLUSH, TEXT("&Flush"));
#if USE_FONT_SETUP==1
		::AppendMenu(hSysMenu, MF_STRING|MF_POPUP, (UINT_PTR)hSubMenu, TEXT("&Setup"));
		::DestroyMenu(hSetupMenu);
#endif
	}
	CreateTrayIcon(hWnd, (HICON)lParam);

	LoadWindowRect(hWnd, FALSE);
	::SetWindowPos( hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

#if USE_FULL_OS_INFO==1
	TCHAR *pszBuf = (TCHAR *)APINew(1024*sizeof(TCHAR));	*pszBuf = 0;
	for (int i=1; g_allVersion[i].szName; i++)
	{
		if ((g_allVersion[i].dwMajor == g_osVersion.dwMajorVersion) &&
			  (g_allVersion[i].dwMinor == g_osVersion.dwMinorVersion))
		{
			wsprintf(pszBuf, szOSInfoFormat, g_allVersion[i].szName, g_osVersion.dwMajorVersion, g_osVersion.dwMinorVersion, g_osVersion.dwBuildNumber, g_osVersion.szCSDVersion, g_shellVersion.dwMajorVersion, g_shellVersion.dwMinorVersion, g_shellVersion.dwBuildNumber);
			break;
		}
	}
	if (!lstrlen(pszBuf))
		wsprintf(pszBuf, szOSInfoFormat, g_allVersion[0].szName, g_osVersion.dwMajorVersion, g_osVersion.dwMinorVersion, g_osVersion.dwBuildNumber, g_osVersion.szCSDVersion, g_shellVersion.dwMajorVersion, g_shellVersion.dwMinorVersion, g_shellVersion.dwBuildNumber);
	::SetWindowText(hWndLog, pszBuf);
	APIFree(pszBuf);
#endif // USE_FULL_OS_INFO==1

	return FALSE;
}

void OnDestroy(HWND hWnd)
{
	g_TrayIcon.HideIcon();
	
#if USE_FONT_SETUP==1
	HKEY hKey;
	DWORD dwDisp, dwSize;
	TCHAR szFontFace[32];
	::RegCreateKeyEx(HKEY_CURRENT_USER, szRegKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	dwSize = 4;
	::RegSetValueEx(hKey, TEXT("FontSize"), 0, REG_DWORD, (LPBYTE)&g_LogFont.lfHeight, dwSize);
	dwSize = 32;
	lstrcpyn(szFontFace, g_LogFont.lfFaceName, 32);
	::RegSetValueEx(hKey, TEXT("FontFace"), 0, REG_SZ, (LPBYTE)&szFontFace, 32);
#endif

	::DeleteObject(g_hLogFont);
	SaveWindowRect(hWnd, FALSE);
}

static const RECT 
	rc1 = {0,0,0,25},
	rc2 = {7,21,45,7},
	rc3 = {47,21,61,7},
	rc4 = {57,21,7,7};

LRESULT OnSize(HWND hWnd, /*WPARAM wFlag, */WORD w, WORD h)
{
	HDWP dwp = ::BeginDeferWindowPos(4);
	RECT rc;
	// Big Edit
	rc = rc1;
	::MapDialogRect(hWnd, &rc);
	rc.right = w - rc.right;
	rc.bottom = h - rc.bottom;
	DEFER_WND_POS(dwp, hWndLog, rc);
	// Static
	rc = rc2;
	::MapDialogRect(hWnd, &rc);
	rc.top = h - rc.top;
	rc.bottom = h - rc.bottom;
	DEFER_WND_POS(dwp, hWndFilterSt/*::GetDlgItem(hWnd, IDC_FILTER_ST)*/, rc);
	rc = rc3;
	::MapDialogRect(hWnd, &rc);
	rc.right = w - rc.right;
	rc.top = h - rc.top;
	rc.bottom = h - rc.bottom;
	DEFER_WND_POS(dwp, hWndFilter/*::GetDlgItem(hWnd, IDC_FILTER)*/, rc);
	// BUTTON
	rc = rc4;
	::MapDialogRect(hWnd, &rc);
	rc.left = w - rc.left;
	rc.right = w - rc.right;
	rc.top = h - rc.top;
	rc.bottom = h - rc.bottom;
	DEFER_WND_POS(dwp, hWndClear/*::GetDlgItem(hWnd, IDC_CLEAR)*/, rc);
	::EndDeferWindowPos(dwp);
	return 0;
}

void OnShow(HWND hWnd)
{
	g_bInTray = FALSE;
	if (g_bTotalHide)
		g_TrayIcon.HideIcon();
	else
		g_TrayIcon.ShowIcon();
	::ShowWindow(hWnd, SW_RESTORE);
}

void OnHide(HWND hWnd)
{
	g_TrayIcon.ShowIcon();
	g_bInTray = TRUE;
	if (g_bTotalHide)
		::ShowWindow(hWnd, SW_HIDE);
	else
		::ShowWindow(hWnd, SW_MINIMIZE);
}

void OnClear()
{
	::SetWindowText(hWndLog, TEXT(""));
}

void OnFlush(TCHAR *pszWhat)
{
	OnClear(); // 
	//      
	if (g_hLogFile)
		WRITE_STR_TO_FILE(g_hLogFile, pszWhat);
	*pszWhat = 0;
}

void FlushIt()
{
	int nLogLen = ::GetWindowTextLength(hWndLog);
	if (!nLogLen)
		return;
	TCHAR *pszNewLog = (TCHAR *)APINew((nLogLen+2)*sizeof(TCHAR));
	::GetWindowText(hWndLog, pszNewLog, nLogLen);
	pszNewLog[nLogLen]=TEXT('\r');
	pszNewLog[nLogLen]=TEXT('\n');
	OnFlush(pszNewLog);
	::SetWindowText(hWndLog, pszNewLog);
	::SendMessage(hWndLog, EM_LINESCROLL, 0, ::SendMessage(hWndLog, EM_GETLINECOUNT, 0, 0));
	APIFree(pszNewLog);
}

BOOL 	OnCopyData(HWND /*hWnd*/, /*HWND hWndFrom, */PCOPYDATASTRUCT pCopyDataStruct)
{
	// pCopyDataStruct->dwData == 0 ANSI String
	// pCopyDataStruct->dwData == 1 UNICODE String
	if ((pCopyDataStruct->dwData != 0 && pCopyDataStruct->dwData != 1) || pCopyDataStruct->cbData==0)
		return TRUE;

	TCHAR *pBuffer = NULL; // Result buffer
#ifdef _UNICODE
	// ANSI String Input
	if (pCopyDataStruct->dwData == 0)
	{
		// Input String
		char *pBufferA = (char*)APINew(pCopyDataStruct->cbData);
		CopyMemory(pBufferA, pCopyDataStruct->lpData, pCopyDataStruct->cbData);
		// Result WCHAR
		int nNeedChars = ::MultiByteToWideChar(CP_ACP, 0, pBufferA, pCopyDataStruct->cbData, NULL, 0);
		WCHAR *pBufferW = (WCHAR *)APINew(nNeedChars*sizeof(WCHAR));
		::MultiByteToWideChar(CP_ACP, 0, pBufferA, pCopyDataStruct->cbData, pBufferW, nNeedChars);
		APIFree(pBufferA);
		pBuffer = (TCHAR*)pBufferW;
	}
	else
	{
		// Unicode String Input
		// Input String
		pBuffer = (TCHAR *)APINew(pCopyDataStruct->cbData);
		CopyMemory(pBuffer, pCopyDataStruct->lpData, pCopyDataStruct->cbData);
	}
#else
	if (pCopyDataStruct->dwData == 0)
	{
	// ANSI String Input
		pBuffer = (TCHAR*)APINew(pCopyDataStruct->cbData);
		CopyMemory(pBuffer, pCopyDataStruct->lpData, pCopyDataStruct->cbData); // No conversion
	}
	else
	{
	// Unicode String Input
		WCHAR *pBufferW = (WCHAR *)APINew(pCopyDataStruct->cbData);
		CopyMemory(pBufferW, pCopyDataStruct->lpData, pCopyDataStruct->cbData);
		int nNeedChars = ::WideCharToMultiByte(CP_ACP, 0, pBufferW, pCopyDataStruct->cbData/sizeof(WCHAR), NULL, 0, NULL, NULL);
		pBuffer = (TCHAR*)APINew(nNeedChars);
		::WideCharToMultiByte(CP_ACP, 0, pBufferW, pCopyDataStruct->cbData/sizeof(WCHAR), pBuffer, nNeedChars, NULL, NULL);
		APIFree(pBufferW);
	}
#endif // _UNICODE
	int nFilterLen = ::GetWindowTextLength(hWndFilter);
	
	BOOL bPutIt = TRUE;
	if (nFilterLen)
	{
		TCHAR *pszFilter = pszFilter = (TCHAR*)APINew((nFilterLen+1)*sizeof(TCHAR));
		::GetWindowText(hWndFilter, pszFilter, nFilterLen+1);
		if (strstr_(pBuffer, pszFilter))
			bPutIt = TRUE;
		else
			bPutIt = FALSE;
		APIFree(pszFilter);
	}
	if (bPutIt)
	{
		int nLogLen = ::GetWindowTextLength(hWndLog);
		DWORD dwNewLen = nLogLen+pCopyDataStruct->cbData+13*sizeof(TCHAR);
		if (dwNewLen)
		{
			TCHAR *pszNewLog = (TCHAR *)APINew(dwNewLen*sizeof(TCHAR));
			::GetWindowText(hWndLog, pszNewLog, dwNewLen);
			if (dwNewLen >= g_lTextLimit)
				OnFlush(pszNewLog);
			TCHAR szTimer[13];
			wsprintf(szTimer, TEXT("%08X: "), ::GetTickCount());
			lstrcat(pszNewLog, szTimer);
			lstrcat(pszNewLog, pBuffer);
			::SetWindowText(hWndLog, pszNewLog);
			::SendMessage(hWndLog, EM_LINESCROLL, 0, ::SendMessage(hWndLog, EM_GETLINECOUNT, 0, 0));
			APIFree(pszNewLog);
		}
	}
	APIFree(pBuffer);
	return TRUE;
}

INT_PTR CALLBACK DialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	if (uMsg == WM_TASKBARCREATED)
	{
		CreateTrayIcon(hwndDlg, g_hTrayIcon);
		return TRUE;
	}

	if (uMsg == WMU_LOGVIEW_CLEAR)
	{
		OnClear();
		return TRUE;
	}
	if (uMsg == UWM_ARE_YOU_ME)
	{
		SetWindowLong(hwndDlg, DWL_MSGRESULT, UWM_ARE_YOU_ME);
		return TRUE;
	}
	switch(uMsg)
	{
		case WM_INITDIALOG:
			return OnInitDialog(hwndDlg, lParam);
		case WM_CLOSE:
		{
			::EndDialog(hwndDlg, 0);
			return TRUE;
		}
		case WM_SIZE:
			return OnSize(hwndDlg, /*wParam, */LOWORD(lParam), HIWORD(lParam));
		case WM_COPYDATA:
			return OnCopyData(hwndDlg, /*(HWND)wParam, */(PCOPYDATASTRUCT) lParam);
		case WM_DESTROY:
		  FlushIt();
			OnDestroy(hwndDlg);
			return FALSE;
		case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
				case IDC_CLEAR:
					OnClear();
					return TRUE;
				case IDCLOSE:
					::SendMessage(hwndDlg,WM_CLOSE,0,0);
					return TRUE;
				case ID_SHOW:
					OnShow(hwndDlg);
					return TRUE;
				case IDC_FLUSH:
					FlushIt();
					return TRUE;
			}
			return FALSE;
		}
		case WM_SYSCOMMAND:
		{
			switch(wParam)
			{
				case SC_RESTORE:
					OnShow(hwndDlg);
					return TRUE;
				case SC_MINIMIZE:
					OnHide(hwndDlg);
					return TRUE;
				case IDC_CLEAR:
					OnClear();
					return TRUE;
				case IDC_FLUSH:
					FlushIt();
					return TRUE;
#if USE_FONT_SETUP==1
				case IDC_FONT:
				{					
					CHOOSEFONT cf;
					static DWORD rgbCurrent;

					// Initialize CHOOSEFONT
					ZeroMemory(&cf, sizeof(CHOOSEFONT));
					cf.lStructSize = sizeof (CHOOSEFONT);
					cf.hwndOwner = hwndDlg;
					cf.lpLogFont = &g_LogFont;
					cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;

					if (ChooseFont(&cf)==TRUE) 
					{
						::DeleteObject(g_hLogFont);
						g_hLogFont = ::CreateFontIndirect(cf.lpLogFont);
						::SendMessage(hWndLog, WM_SETFONT, (WPARAM)g_hLogFont, TRUE);
					}
					return TRUE;
				}
#endif
			}
			return FALSE;
		}
		case WM_GETMINMAXINFO:
		{
			RECT rc = {0,0,150, 100};
			::MapDialogRect(hwndDlg, &rc);
			((LPMINMAXINFO)lParam)->ptMinTrackSize.x = rc.right;
			((LPMINMAXINFO)lParam)->ptMinTrackSize.y = rc.bottom;
			return TRUE;
		}
		case WM_USER:
			return g_TrayIcon.OnTrayNotification(wParam, lParam);
		case WM_SHOWWINDOW:
			if (wParam && g_bInTray)
				OnShow(hwndDlg);
			else if (!wParam && !g_bInTray)
				OnHide(hwndDlg);
			return FALSE;
//		case WM_INITMENU:
		case WM_INITMENUPOPUP:
		{
			HMENU hMenu = (HMENU)wParam;
			int nLogLen = ::GetWindowTextLength(hWndLog);
			::EnableMenuItem(hMenu, IDC_CLEAR, MF_BYCOMMAND|(nLogLen?MF_ENABLED:(MF_DISABLED|MF_GRAYED)));
			::EnableMenuItem(hMenu, IDC_FLUSH, MF_BYCOMMAND|(nLogLen?MF_ENABLED:(MF_DISABLED|MF_GRAYED)));
			::EnableMenuItem(hMenu, ID_SHOW, MF_BYCOMMAND|(g_bInTray?MF_ENABLED:(MF_DISABLED|MF_GRAYED)));
			return TRUE;
		}
		default:
			return FALSE;
	}
}

BOOL CALLBACK searcher(HWND hWnd, LPARAM lParam)
{
	DWORD result;
	LRESULT ok = ::SendMessageTimeout(hWnd,UWM_ARE_YOU_ME,0,0,
		SMTO_BLOCK|SMTO_ABORTIFHUNG,200,
		&result);
	if(ok == 0)
		return TRUE; //     
	if(result == UWM_ARE_YOU_ME)
	{ /*  */
		HWND * target = (HWND *)lParam;
		*target = hWnd;
		return FALSE; //  
	} /*  */
	return TRUE; //  
} // searcher


int APIENTRY __WinMain__()
{
	LPTSTR lpCmdLine = ::GetCommandLine();

	WMU_LOGVIEW_CLEAR = RegisterWindowMessage(TEXT("LogViewClearWindow"));
	UWM_ARE_YOU_ME = RegisterWindowMessage(TEXT("EC639BF0-A932-405F-8895-16CBA8FB90B9"));
	WM_TASKBARCREATED = ::RegisterWindowMessage(TEXT("TaskbarCreated"));
	g_hModule = ::GetModuleHandle(NULL);
	g_hHeap = ::GetProcessHeap();

	::CharUpper(lpCmdLine);
	if (strstr_(lpCmdLine, TEXT("REGSERVER")) || strstr_(lpCmdLine, TEXT("UNREGSERVER")) )
	{
		return 1;
	}
	TCHAR *pos = strstr_(lpCmdLine, TEXT("-L"));
	if (pos)
	{
		pos += 2;
		while (*pos && *pos!=TEXT(' ')) pos++;
		int p = 1;
		while (*--pos != TEXT('L'))
		{
			g_lTextLimit += p*(*pos-TEXT('0'));
			p*=10;
		}
	}

	
	g_posVersion = (OSVERSIONINFO*)APINew(sizeof(OSVERSIONINFO));
	g_osVersion.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	g_pshellVersion = (DLLVERSIONINFO*)APINew(sizeof(DLLVERSIONINFO));
	g_shellVersion.cbSize = sizeof(DLLVERSIONINFO);

	::GetVersionEx(&g_osVersion);
	if (!g_lTextLimit)
		if (g_osVersion.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{
			g_lTextLimit = (DWORD)-1;
		}
		else
		{
			g_lTextLimit = 0xFFFF;
		}

	HINSTANCE hShell32 = ::LoadLibrary(TEXT("shell32.dll"));
	if (hShell32)
	{
    DLLGETVERSIONPROC pDllGetVersion;
    pDllGetVersion = (DLLGETVERSIONPROC) GetProcAddress(hShell32, "DllGetVersion");
    if(pDllGetVersion)
      (*pDllGetVersion)(&g_shellVersion);
    FreeLibrary(hShell32);
  }

	BOOL AlreadyRunning;

	HANDLE hMutexOneInstance = ::CreateMutex( NULL, FALSE,
		szMutexName);
	
	//    
	// UID    
	//  createExclusionName
	DWORD dwLastError = ::GetLastError();
	AlreadyRunning = (dwLastError == ERROR_ALREADY_EXISTS || 
		dwLastError == ERROR_ACCESS_DENIED);
	//   ERROR_ACCESS_DENIED,    
	//    , ..   
	// SECURITY_ATTRIBUTES     NULL
	
	if ( AlreadyRunning )
	{ /*     */
		HWND hOther = NULL;
		EnumWindows(searcher, (LPARAM)&hOther);
		
		if ( hOther != NULL )
		{ /*     */
			::SetForegroundWindow( hOther );
			if ( IsIconic( hOther ) || !::IsWindowVisible(hOther))
			{ /*   */
				::ShowWindow( hOther, SW_RESTORE );
			} /*   */
		} /*     */
    return 1; //  
	} /*     */
	// ...  ...
	g_pTrayIcon = (CTrayIcon *)APINew(sizeof(CTrayIcon));
	g_TrayIcon.m_bHidden = FALSE;
	g_TrayIcon.m_bEnabled = FALSE;
//ICON hIcon = ::LoadIcon(g_hModule, MAKEINTRESOURCE(IDI_ICON));
	TCHAR *szLogFilename = (TCHAR *)APINew(MAX_PATH*sizeof(TCHAR));
	::GetModuleFileName(NULL, szLogFilename, MAX_PATH);
	pos = szLogFilename+lstrlen(szLogFilename);
	while (*--pos != TEXT('.') && pos >= szLogFilename);
	lstrcpy(pos+1, TEXT("log"));
	g_hLogFile = ::CreateFile(szLogFilename, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_WRITE_THROUGH, NULL);
	if (g_hLogFile)
	{
		::SetFilePointer(g_hLogFile, 0, 0, FILE_END);
		SYSTEMTIME st;
		::GetLocalTime(&st);
		wsprintf(szLogFilename, TEXT("LogView Started at: %d.%d.%d %d:%d:%d.%d\n"), st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
		WRITE_STR_TO_FILE(g_hLogFile, szLogFilename);
	}

	g_hTrayIcon = (HICON)LoadImage(g_hModule, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	::DialogBoxParam(g_hModule, MAKEINTRESOURCE(IDD_DIALOG), ::GetDesktopWindow(), DialogProc, (LPARAM)g_hTrayIcon);
	::DestroyIcon(g_hTrayIcon);
	
	APIFree(szLogFilename);
	APIFree(g_pTrayIcon);
	APIFree(g_posVersion);
	APIFree(g_pshellVersion);

	::CloseHandle(g_hLogFile);
	::CloseHandle(hMutexOneInstance);
	return 0;
}



