// TrayIcon.h: interface for the CTrayIcon class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRAYICON_H__AF5544D8_235F_4EE6_AC01_EA7691F6C920__INCLUDED_)
#define AFX_TRAYICON_H__AF5544D8_235F_4EE6_AC01_EA7691F6C920__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Tray Icon
class CTrayIcon
{
	struct NOTIFYICONDATA_U : public NOTIFYICONDATA
	{
		struct _DUMMY_
		{
      DWORD cbSize;
      HWND hWnd;
      UINT uID;
      UINT uFlags;
      UINT uCallbackMessage;
      HICON hIcon;
      TCHAR   szTip[64];
		};
		NOTIFYICONDATA_U()
		{
			extern DLLVERSIONINFO *g_pshellVersion;
			ZeroMemory(this, sizeof(NOTIFYICONDATA));
			if (g_pshellVersion->dwMajorVersion < 5)
				cbSize = sizeof(_DUMMY_);
			else
				cbSize = NOTIFYICONDATAA_V1_SIZE;
		}
	};
public:
	BOOL m_bHidden;
	BOOL m_bEnabled;
	NOTIFYICONDATA_U m_tnd;
	
	void HideIcon()
	{
		if (m_bEnabled && !m_bHidden) 
		{
			m_tnd.uFlags = NIF_ICON;
			Shell_NotifyIcon (NIM_DELETE, &m_tnd);
			m_bHidden = TRUE;
		}
	}
	void ShowIcon()
	{
		if (m_bEnabled && m_bHidden) 
		{
			m_tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP | NIF_INFO;
			m_tnd.uTimeout = 15000;
			Shell_NotifyIcon(NIM_ADD, &m_tnd);
			m_bHidden = FALSE;
		}
	}
	BOOL CreateTrayIcon(HWND hWnd, UINT uMsgCallBack, LPCTSTR szTooltip, HICON hIcon, UINT uID, LPCTSTR szInfoTitle = NULL, LPCTSTR szInfo = NULL);
	LRESULT OnTrayNotification(UINT wParam, LONG lParam);
};

#endif // !defined(AFX_TRAYICON_H__AF5544D8_235F_4EE6_AC01_EA7691F6C920__INCLUDED_)
